          SECTION D                                               FILE EXTRA.D
                    How a computer stores and processes information
                    ***********************************************

          It is easy to accept what a computer does without ever wondering how
          it does it. This file gives a gentle introduction into how a
          computer functions at the lowest level, and I hope will persuade you
          to delve deeper into the subject. Whilst not essential for
          programming in BASIC, a knowledge of how your computer operates is
          very desirable, as is some familiarity with  Binary and Hexadecimal
          number systems.

          A computer can react to only one signal, voltage high or low,
          generated by a switch being on or off, but it reacts at phenomenal
          speed.  The first computers were given information by a bank of
          switches, which were set manually  by the operator, recorded
          electronically, set again and recorded and so on; a very painstaking
          operation!. You can do this today by pressing  keys on your
          keyboard. This generates  patterns of eight on/off signals, which
          the computer recognises and translates into action. Each signal, on
          or off, is called a "BIT", short for 'Binary digIT' and is the
          smallest unit of computer information. BITs are assembled into
          groups of eight, which are called "BYTEs". Occasionally you may see
          a "NIBBLE" referred to,  which is four BITs, or half a BYTE
          .......Honest !!!

          The signals are stored temporarily in memory as electrical charges,
          and have to be refreshed at frequent intervals to maintain them,
          which is why they are lost when the computer is shut down. The
          signals can be stored more permanently on disc as magnetic charges.

          We need to label and control these signals, in order to be able to
          use the computer, and one way is to call each 'on' signal the figure
          1 and each 'off signal the figure 0. If the signal is 'on' it is
          said to be SET and if it is off it is RESET. Since signals are
          stored in BYTEs (blocks of eight signals), a typical byte could be
          represented as  00101100  where as you can see, three BITs are SET
          and 5 BITs are RESET. I want you to hold on to the fact that the
          only 'language' that any computer can use is a series of electrical
          signals. Anything typed at the keyboard has to be converted into
          bytes of electrical signals before it can be processed by the
          computer.

          BINARY SYSTEM   Usually we use the decimal system for counting,
          =============   and making calculations, using the ten figures
          0,1,2,3,4,5,6,7,8,9.  Other systems are used; for example the Octal
          system, occasionally used in computing which uses only the eight
          figures 0,1,2,3,4,5,6,7 and the Hexadecimal system which is used
          extensively in computing and uses the sixteen figures and letters
          0,1,2,3,4,5,6,7,8,9,A,B,C,D,E,F., but just now I want to introduce
          you to the Binary system, which uses just two figures ; 0 and 1. You
          will see that this system fits in well with the way a computer works
          as described previously. Any byte can be represented in binary.
          As mentioned before, pressing a key on the keyboard of a computer
          generates a pattern of eight signals which the computer can
          translate into a character or command. So if you type in BASIC
                      PRINT 3+5, then press [RETURN], you will expect to get
          the answer 8 printed. This is all done, remember, by electrical
          signals. The word PRINT triggers an electrical  response to show the
          result on the screen, but arithmetic is also performed to add 3 and
          5. The eight-bit electrical signals for 3 and 5 are combined to get
          the answer 8 and the way it is done follows the same rules as for
          Binary Arithmetic. A study of binary arithmetic is necessary if you
          want to go far in writing Machine Code or designing computer
          circuits, and there are many books on the subject if you are
          interested.  Suffice it to say that binary numbers are added,
          subtracted etc., in just the same way as decimal numbers, but they
          have the drawback that they are unwieldy and difficult to recognise.
          For example, spot the difference between  01010001 and 00101001; not
          too difficult perhaps, but imagine looking at several dozen similar
          numbers!. I think your powers of concentration would be tested. This
          is one reason why the Hexadecimal System is used rather than Binary
          for displaying bytes.

          HEXADECIMAL SYSTEM   The hexadecimal system uses sixteen characters;
          ==================   the figures 0,1,2,3,4,5,6,7,8,9 are used as in
          decimal,  and letters A,B,C,D,E,F represent 10,11,12,13,14,15
          decimal. In decimal, as you will know,  the rightmost figure
          represents ones, the figure to it's left represents 10's, the next
          100's etc. In Hexadecimal, the rightmost figure represents ones, but
          the figure to it's left represents 16's, the next 256's etc., each
          column representing 16 times the value of the column to it's right.

          The following table gives equivalent bytes in terms of Binary, Hex.
          and Decimal

          Binary              Hexadecimal                   Decimal
          ======              ===========                   =======
          00000000            00                            0
          11111111            FF                            256
          00001111            0F                            16
          11110000            F0                            240
          00110011            33                            51
          00111100            3C                            60

          The advantages of Hex. over Decimal and Binary for representing
          bytes is easy to see. At most, only two Hex. figures are needed to
          represent any byte; in practice two are usually used even when one
          would do (see examples 1 and 3 above). See also how easy it is to
          convert from Binary to Hex. and vice versa. Each half-byte or nibble
          can be converted separately to get the correct result i.e 1111 = F,
          0011 = 3, 1100 = C etc. Similar conversions between Binary and
          Decimal are more difficult.

          To distinguish hexadecimal numbers from decimal, it is usual to add
          the letter H after the number e.g F4H or F4h. When using hexadecimal
          numbers in Mallard Basic the number has to be prefixed by &H for the
          same reason e.g  &H3C.

          RECAPPING   All the functions of a computer are accomplished by the
          =========   manipulation of electrical signals in batches of eight
          called bytes, and bytes can be represented by various systems, of
          which  binary, hexadecimal, or decimal are most commonly used. Each
          system has it's use.  Binary arithmetic allows the most graphic
          representation of what happens during the manipulation of bytes, and
          is important for a full understanding of how a computer processes
          information. Hexadecimal and decimal numbers are used by programmers
          to enter data into a program. This is usually a matter of choice but
          on some occasions hexadecimal is more convenient; for example when
          preparing DATA lines for reading in to an array.

            Let us have a look at the way various tasks are accomplished.
          Keeping track of data- ADDRESSES  Information is stored in memory in
          ================================  cells, each of which  can hold one
          byte, and each cell location is labelled with a number called the
          ADDRESS of the cell. One byte can only represent numbers from 0 to
          255, so in CP/M, addresses are held in two bytes which allow up to
          65536 addresses, or in other words, two bytes allow 64K to be
          addressed. ( 1K or Kilobyte is 1024 bytes... yes, I know that it
          should be 1000 bytes, but 1024 is the nearest round binary number.)
          Calling an address puts a copy of the byte at that address into the
          Central Processing Unit for processing, leaving the original byte
          unchanged. Only one byte is processed at a time, but at incredible
          speed.

          MATHEMATICS  Since one byte can only represent up to 256 decimal
          ===========  this might not seem too healthy for the mathematician,
          but bytes can be strung together to make larger numbers. As we have
          seen, two bytes together can represent up to 65536 and so on. For
          very large and very small numbers a special notation is used; for
          example  1.31072E+07 is 13107200 and  1.31072E-03 is .00131072 which
          saves on memory.

          Minus numbers are catered for, as are calculations involving fixed
          decimal places such as money arithmetic. One or more BITs in a byte
          may be used as a code to identify the type of number held in that
          byte and/or subsequent bytes.

          At it's roots, a computer can only add and subtract, all other
          calculations are cleverly contrived, but mathematical methods of
          operation are best studied using the Binary system if you are
          interested.

          LETTERS and SYMBOLS   Each letter or symbol is represented by a
          ===================   number. For example 01000001 represents A.
          01000001 = 41 Hex or 65 decimal. The value for each character is
          standardised by the ACSII code which embraces all codes from
          00000000 to 01111111; 0 to 7F Hex., 0 to 127 decimal. There is a
          table of ASCII codes in the CP/M manual supplied with your machine.
          In this table you will actually find values up to 255 decimal, but
          only those up to 127 are universally recognised as ASCII code; the
          others may vary from system to system.

          The ASCII code uses only 7 bits of the byte to get it's 128 values,
          leaving the highest bit for possible other uses. the 256 values use
          all eight bits of the byte.

          COMMANDS AND ACTIONS   If we use the command PRINT "Hello" in BASIC,
          ====================   a string of electrical signals (in bytes) are
          generated which cause the computer to do as you wish. Some signals
          are codes which indicate that a command is expected next etc.
          Commands similar to PRINT "Hello" are found in all languages,
          including machine code. Although the command may look different, it
          must always finally generate the same bytes of electrical signals.

          POSTSCRIPT  At the moment you may think that this file is not
          ==========  relevant to your needs, but in fact it tells you what
          MALLARD BASIC is. It is an environment in which certain commands
          typed or otherwise put into that environment are converted into the
          correct sequence of electrical signals to achieve results. BASIC
          commands typed into another language will not give results, nor will
          unrecognised commands work in BASIC. This is why strings have to be
          put inside double quotes, why lines have to be numbered, why
          Hexadecimal numbers have to be prefixed by &H, why all these
          seemingly petty rules must be followed. It is simply to ensure that
          the correct electrical signals are sent in the right order!.

          End of file EXTRA.D
imply to ensure that
          the correct electrical signals are sent in the r