          SECTION B                                                       FILE MORE.B
                                         More Keywords
                                         *************

          This file gives a brief description of general purpose keywords that
          have not been used so far in BASTUTOR. You are unlikely to need them
          very often, but take a little time now to look them over, so as to
          at least recognise them if they appear in a program which you are
          copying or studying. Where possible, write a line or two of BASIC to
          check for yourself what they do. Keywords marked * are demonstrated in the
          BASIC program following this text.

          * CINT    MATHS: Converts a value to integer if possible.
                              FORM :-  CINT(number)
                    In BASIC try  PRINT CINT(5.728) and see that BASIC returns
                    6. Try other numbers. Only valid between -32768 and +32767

          * CSNG    MATHS: Converts a double length number to a single length
                    number
                              FORM :-   CSNG(number)
                    In BASIC try PRINT CSNG(5.10023650034) and similar numbers.
                            See also CDBL above

          * CDBL    MATHS: Converts a single length number to a double length
                    number for greater accuracy, but note that some strange
                    results may occur due to conversion by the computer between
                    binary and decimal arithmetic.
                              FORM :-   CDBL(number)
                    In BASIC try  PRINT CDBL(.1) and see that BASIC returns
                    .1000000014901161, then try other numbers. Your PCW is not
                    so accurate as a calculator for floating point arithmetic

          * UNT     MATHS: Converts any number between -32768 and 65535 to an
                    unsigned integer which can be stored in two bytes. Primarily used
                    for machine memory addresses.
                              FORM:- UNT(address-expression).
                    Numbers with a decimal fraction are converted to the nearest
                    integer, then processed as follows. -32768 to +32767 remain
                    unchanged. +32768 to 65535;  number -65535 .
                              e.g UNT(65000)= -535 i.e 65000-65535= -535.

          COMMON RESET    RESETS all variables ie, makes them zero,except
                         those specifically named using the COMMON statement.
                         CLEAR resets ALL variables. See INTER.J
                              FORM :- type COMMON RESET where required.

          DISPLAY   Similar command to TYPE
                              FORM:-   DISPLAY filename.filetype

          ERL       Used in error handling subroutines to report the line number
                    in which an error occurs

          ERR       Used in error handling subroutines to report the error
                    number.

          FILES     Similar to DIR, but more restricted
                              FORMS:- FILES    Displays all files on current drive
                                      FILES "*.BAS"  Displays all .BAS files
                                      FILES "B:*.COM" Displays .COM files on drive B

          FIND$     Used to identify or find a file on disc. Seems to be fairly
                    specific and will only find one file at a time.
                              FORMS:- PRINT FIND$ ("??MPLATE.*")  Will find
                              TEMPLATE.STD.

                    In BASIC try typing PRINT FILE$("filename.ext") where
                    filename.ext is a file that you know is on disc, then
                    try using wildcards.

          LET       It is not necessary to use LET; I don't know why it is still
                    retained. In some BASICs one has to write LET a=3 when
                    assigning a variable but in MALLARD BASIC it is redundant.

          LPOS      Supposed to show the theoretical position of the print head.
                    Suppose it has it's uses, but can't figure it at the moment.
                              FORM:- LPOS(0)
                    In BASIC type the following line then run it. Make sure you
                    have paper in the printer first:-
                    10 LPRINT "Have a nice day" LPOS(0) "Thanks, and you!" LPOS(0)
                            Try variations on this theme

          * OPTION NOT TAB      Turns off Tab expansion
                                        FORM:- OPTION NOT TAB
                    When writing code, you may use the [TAB] key to enhance the
                    listing layout. OPTION NOT TAB causes spaces thus made to be
                    ignored when sent to screen or printer. Uses ? - Screen or
                    printer presentation. Used with OPTION TAB could indent selected
                    lines and leave others. See BASIC program following.

          * OPTION TAB       Reverses above command
                                        FORM:- OPTION TAB
          OPTION RUN     Disables the use of Control-C and Control-S from the
                         keyboard; that is, it prevents the program being stopped
                         by the use of the [STOP] key. Useful for use with an
                         unskilled operator or where stopping a program part-way
                         could leave the computer in an awkward state, such as
                         reverse video.
                              FORM:- OPTION RUN   use at the start of the program

          OPTION STOP    Cancels OPTION RUN
                              FORM:- OPTION STOP

          * POS     Similar to LPOS but concerns the console (screen) only.
                              FORM:- POS(0)
                    In BASIC type PRINT "Have a nice day"POS(0)"Thanks!"POS(0)
                    and see how the number of characters is shown. Experiment
                    with various combinations. Can't see a serious application
                    at present, but probably will one day. Varying the number in
                    the brackets makes no difference; it is what is called a
                    dummy argument. Does this mean that the Author of MALLARD
                    BASIC didn't complete this function?.

          RANDOMIZE      Note the 'z' in the spelling. RANDOMIZE is used to
                         provide a "seed" for use with random numbers.
                              FORM:-  RANDOMIZE
                         When run, this prints "Random number seed", and waits
                         for an input. RANDOMIZE is used with the random number
                         function RND. This is dealt with fully in file MORE.J
                         in this section

          RND       Used to provide random numbers for use in games, puzzles,
                    etc. See MORE.J

          * SPACE$  To create a string of spaces of a given length
                              FORM:- SPACE$(21)  or SPACE$(n) where n is a number
                              variable

          * SPC     Similar to SPACE$ but creates a number of spaces as
                    distinct from a string of spaces. This makes a
                    difference because BASIC checks if a string will fit on
                    the current line and if not, issues a carriage return so
                    that the string starts a new line. This can obviously
                    make a difference to layout. Also, SPC can only be used
                    in a PRINT command
                              FORM:-SPACE$(32)  or SPACE$(N) where n is a number
                              variable

          * STR$    Converts a number to a string
                              FORM:- STR$(65.78)
                    Doesn't seem to be used much. Numbers can be put into
                    string variables e.g a$=45.3456 and retrieved by VAL

          * STRING$ Prints a string of a given character a specified number
                    of times
                              FORM:- STRING$(40,"+")
          The example above would generate a string of 40 '+' characters.

          * STRIP$  Forces each character in a string into the normal ASCII range by
                    making the highest bit (Bit 7) a zero; thus the highest value of
                    the byte is 127. Characters in the range 128-255 are reduced in
                    value by 128, so 	 (No. 165) would be converted to | (No.37).
                    Mainly used for transferring data betwwen machines to ensure
                    compatibility.
                              FORM:- STRIP$(string-expression)

          TRON      (TRace ON) Sets a trace on line numbers
                              FORM:- TRON
                    Used for debugging. Type TRON in direct mode and press
                    [RETURN] Thereafter any program run will show program
                    line numbers. Described fully in MORE.D

          TROFF     (TRace OFF) Cancels TRON
                              FORM:- TROFF... Used from direct mode as TRON

          VERSION   Shows the version of BASIC which is being used.
                              FORM:- VERSION(n)  where n is a number from 0 to 4
                                   Sometimes a program may need to know which version
                                   of BASIC it is running under, but mostly this
                                   function is a curiousity. The following table
                                   shows how the numbers returned by VERSION are
                                   interpreted.

                    Number (n)     Returned  Meaning

                         (0)       7         8080/8085 version of BASIC
                                   8         Z80 version of BASIC
                                   16        8088/8086 version of BASIC

                         (0)       0         Full BASIC Interpreter
                         (1)       1         Run-Only BASIC Interpreter

                         (2)       1         Single-User BASIC
                                   2         Multi-user BASIC for Concurrent CP/M-86

                         (3)       1         CP/M BASIC
                                   2         MS-DOS (PC-DOS) BASIC

                         (4)       *         Other information dependent on version.


                    Try the command PRINT VERSION(0) etc. and interpret the
                    results with the table above. You should find that you are
                    using a Z80, Full Interpreter, Single-user,CP/M BASIC. If
                    you try parameter(4) you will probably get 49 which I
                    believe ties down the version even further.

          WIDTH     Sets the length of lines which are printed on the screen .

                              FORM:- WIDTH(n) where n is the number of characters to
                                   be printed per line, including spaces. Can be used
                                   from within a program for special layout effect
                                   or from direct mode. The 'Antidote' is WIDTH(90),
                                   which returns you to full length lines.

          WIDTH LPRINT   Same as WIDTH, but affects lines sent to the
                         printer.
                              FORM:- WIDTH(n) where n is the number of characters to
                                   be printed per line.

          * WRITE   Similar to the PRINT command.
                              FORM:- WRITE "Hello", 45,"world; 3+5 ... note that
                                   either a comma or a semicolon may be used as a
                                   separator.  WRITE differs from PRINT in that it
                                   prints out strings in  double quote marks, takes
                                   no account of print zones and adds commas between
                                   the printed items.  Neither can separate program
                                   lines of WRITE commands be made to print out on
                                   one line by terminating lines with a
                                   semi-colon.(Known as a trailing separator).  In
                                   the form given, "Hello" and "world" would be
                                   printed with quotes, 45 without quotes, and 3+5
                                   printed as 8, all separated with a comma. Try
                                   it!!.

          CONCLUSION  Some of the above keywords (those marked *) are demonstrated in
          ==========  the listing following this text. Some appear to duplicate
          others and a few seem to be too far out to be useful. However, all have
          their uses, given the right conditions, and should be kept in mind. Try out
          as many as you can of these keywords, either writing short programs in
          BASIC , say up to 6 lines, or try them from direct mode. When using the
          latter don't forget to use the left cursor arrow key (or [ALT]+A") to
          repeat the command. Write the command, press [RETURN] to execute it, then
          press the arrow key. The command will reappear, can be modified and
          re-tried as many times as you like to enable you to find the limits of the
          command. A real time-saver!.

          END OF FILE MORE.B
s as you like to enable you to find the limits of the
          command. A real time-saver!.
